<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function selfban_add_permissions (&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	$permissionList['membergroup']['profile_selfban'] = array(false, 'profile', 'delete_account');
}

function selfban_add_profile_menu (&$profile_areas)
{
	global $txt, $context;

	$profile_areas['profile_action']['areas']['selfban'] = array(
		'label' => $txt['profileBanAccount'],
		'file' => 'Subs-Selfban.php',
		'function' => 'selfbanAccount',
		'password' => true,
		'permission' => array(
			'own' => array('profile_selfban'),
			'any' => array(),
		),
	);
}

// Present a screen to make sure the user wants to be banned
function selfbanAccount ()
{
	global $txt, $context, $user_info, $modSettings, $cur_profile, $smcFunc, $settings;

	if ($context['user']['is_owner'])
		isAllowedTo('profile_selfban');

	if (isset($_REQUEST['save']) && empty($context['selfban_errors']))
		selfbanAccount2();

	loadTemplate('Selfban');
	loadLanguage('Admin');

	$context['page_title'] = $txt['banAccount'] . ': ' . $cur_profile['real_name'];

	$context['ban']['reason'] = isset($_POST['reason']) ? $_POST['reason'] : '';
	$context['ban']['expiration']['status'] = isset($_POST['expiration']) ? ($_POST['expiration']=='never' ? 'never' : 'still_active_but_we_re_counting_the_days') : 'still_active_but_we_re_counting_the_days';
	$context['ban']['expiration']['days'] = isset($_POST['expire_date']) ? (int) $_POST['expire_date'] : 0;
	$context['ban']['cannot']['post'] = empty($_POST['cannot_post']) ? 0 : 1;
	$context['ban']['cannot']['login'] = empty($_POST['cannot_login']) ? 0 : 1;

	if(!empty($context['selfban_errors'])){
		$context['selfban_errors']['messages'] = array();
		foreach($context['selfban_errors'] as $error)
			if(!empty($error))
				$context['selfban_errors']['messages'][] = $txt['selfban_error_' . $error];
	}

	if(empty($context['html_headers']))
		$context['html_headers'] = '';

	$context['html_headers'] .= '
	<style type="text/css">
		.ban_restriction
		{
			margin: 0.2em 0 0.2em 2.2em;
		}
		.ban_settings
		{
			width: 46%;
		}
		#manage_bans dl
		{
			margin-bottom: 1em;
		}
		#manage_bans fieldset dl.settings
		{
			margin-bottom: 0;
		}
	</style>';
}

function selfbanAccount2 ()
{
	global $context, $sourcedir, $user_info, $smcFunc;

	checkSession();
	$context['selfban_errors'] = array();

	$_POST['reason'] = $smcFunc['htmlspecialchars']($_POST['reason'], ENT_QUOTES);
	$_POST['reason'] = trim($_POST['reason']);
	$_POST['expire_date'] = (int) $_POST['expire_date'];

	if(empty($_POST['reason']))
		$context['selfban_errors']['reason'] = 'reason';
	if(empty($_POST['expire_date']) || $_POST['expire_date'] < 0)
		$context['selfban_errors']['expire_date'] = 'expire_date';
	if(!isset($_POST['cannot_post']) && !isset($_POST['cannot_login']))
		$context['selfban_errors']['cannot'] = 'cannot';

	if(!empty($context['selfban_errors']))
		return selfbanAccount();

	$ban_name = 'Self-ban: ' . $smcFunc['htmlspecialchars']($user_info['username'], ENT_QUOTES);
	$_POST['expiration'] = time() + 24 * 60 * 60 * (int) $_POST['expire_date'];
	$_POST['cannot_post'] = empty($_POST['cannot_post']) ? 0 : 1;
	$_POST['cannot_login'] = empty($_POST['cannot_login']) ? 0 : 1;
	$_POST['ban_suggestion'][] = 'user';

	// Check whether a ban with this name already exists.
	$request = $smcFunc['db_query']('', '
		SELECT id_ban_group
		FROM {db_prefix}ban_groups
		WHERE name = {string:new_ban_name}
		LIMIT 1',
		array(
			'new_ban_name' => $ban_name,
		)
	);
	if ($smcFunc['db_num_rows']($request) == 1)
	{
		$newBan = false;
		list($ban_group) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}ban_groups
			SET
				name = {string:ban_name},
				reason = {string:reason},
				notes = \'\',
				ban_time = {int:ban_time},
				expire_time = {raw:expiration},
				cannot_access = 0,
				cannot_post = {int:cannot_post},
				cannot_register = 0,
				cannot_login = {int:cannot_login}
			WHERE id_ban_group = {int:id_ban_group}',
			array(
				'expiration' => $_POST['expiration'],
				'ban_time' => time(),
				'cannot_post' => $_POST['cannot_post'],
				'cannot_login' => $_POST['cannot_login'],
				'id_ban_group' => $ban_group,
				'ban_name' => $ban_name,
				'reason' => $_POST['reason'],
			)
		);
	} else {
		$newBan = true;
		$smcFunc['db_insert']('',
			'{db_prefix}ban_groups',
			array(
				'name' => 'string-20', 'ban_time' => 'int', 'expire_time' => 'raw', 'cannot_access' => 'int', 'cannot_register' => 'int',
				'cannot_post' => 'int', 'cannot_login' => 'int', 'reason' => 'string-255', 'notes' => 'string-65534',
			),
			array(
				$ban_name, time(), $_POST['expiration'], 0, 0,
				$_POST['cannot_post'], $_POST['cannot_login'], $_POST['reason'], '',
			),
			array('id_ban_group')
		);
		$ban_group = $smcFunc['db_insert_id']('{db_prefix}ban_groups', 'id_ban_group');
	}

	$request = $smcFunc['db_query']('', '
		SELECT id_ban_group
		FROM {db_prefix}ban_items
		WHERE id_member = {string:id_member}
			AND id_ban_group = {int:id_ban_group}
		LIMIT 1',
		array(
			'id_member' => $user_info['id'],
			'id_ban_group' => $ban_group,
		)
	);
	if ($smcFunc['db_num_rows']($request) == 0)
	{
		$ban_triggers = array(
			$ban_group,
			0, 0, 0, 0, 0, 0, 0, 0,
			'',
			'',
			(int) $user_info['id'],
		);
		$ban_cols = array(
			'id_ban_group' => 'int', 'ip_low1' => 'int', 'ip_high1' => 'int', 'ip_low2' => 'int', 'ip_high2' => 'int',
			'ip_low3' => 'int', 'ip_high3' => 'int', 'ip_low4' => 'int', 'ip_high4' => 'int',
			'hostname' => 'string-255',
			'email_address' => 'string-255',
			'id_member' => 'int',
		);

		$smcFunc['db_insert']('',
			'{db_prefix}ban_items',
			$ban_cols,
			$ban_triggers,
			array('id_ban')
		);
		$smcFunc['db_free_result']($request);
	}
	$modlogInfo['member'] = $user_info['id'];

	// Log the addion of the ban entry into the moderation log.
	logAction('ban', $modlogInfo + array(
		'new' => $newBan,
		'type' => 'user_ban',
	));
	require_once($sourcedir . '/ManageBans.php');
	updateSettings(array('banLastUpdated' => time()));
	updateBanMembers();
	require_once($sourcedir . '/Security.php');
	is_not_banned(true);
	redirectexit('action=profile');
}

?>